## ess 18.10.2

=== Makefile ===
## Top Level Makefile

## Before making changes here, please take a look at Makeconf
include ./Makeconf

## 'all' is the default target, i.e. 'make' and 'make all' are the same.
.PHONY: all install uninstall
all install uninstall: $(ETC_FILES)
	cd lisp; $(MAKE) $@
	cd doc; $(MAKE) $@
	cd etc; $(MAKE) $@

.PHONY: version
version:
	@echo "********************* VERSIONS **************************"
	@echo $(shell $(EMACS) --version | sed -n 1p)
	@echo ESS $(ESSVERSION)
	@echo "*********************************************************"

.PHONY: lisp
lisp: version
	cd lisp; $(MAKE)

.PHONY: doc
doc: version
	cd doc; $(MAKE)

.PHONY: etc
etc: version
	cd etc; $(MAKE)

.PHONY: test
test: version
	cd test; $(EMACS) --script run-tests

generate-indent-cases:
	cd test; $(EMACS) --script generate-indent-cases

.PHONY: julia
julia:
	cd lisp; $(MAKE) julia-mode.el

.PHONY: autoloads
autoloads:
	cd lisp; $(MAKE) ess-autoloads.el

## the rest of the targets are for ESS developer's use only :

## --- PRE-release ---

# Create .tgz and .zip files only
# GNUTAR=gtar make tarballs
tarballs: $(ESSDIR)
	@echo "**********************************************************"
	@echo "** Making distribution of ESS for (pre)release $(ESSVERSION) from $(ESSDIR)/"
	@echo "** Making pdf and html documentation"
	cd $(ESSDIR)/doc/ ; $(MAKE) pdf
	cd $(ESSDIR)/doc/ ; $(MAKE) html
	@echo "** Creating .tgz file **"
	test -f $(ESSDIR).tgz && rm -rf $(ESSDIR).tgz || true
	$(GNUTAR) hcvofz $(ESSDIR).tgz $(ESSDIR)
	@echo "Signing tgz file"
	$(GPG) -ba -o $(ESSDIR).tgz.sig $(ESSDIR).tgz
	@echo "** Creating .zip file **"
	test -f $(ESSDIR).zip && rm -rf $(ESSDIR).zip || true
	zip -r $(ESSDIR).zip $(ESSDIR)
	@echo "Signing zip file"
	$(GPG) -ba -o $(ESSDIR).zip.sig $(ESSDIR).zip
	touch $@

# Create the "release" directory
# run in the foreground so you can accept the certificate
# NB 'all', 'cleanup-dist' must not be targets: otherwise, e.g.
#    'make tarball' re-builds the tarballs always!
$(ESSDIR): RPM.spec
	$(MAKE) all
#	remove previous ESSDIR, etc:
	$(MAKE) cleanup-dist
	@echo "**********************************************************"
	@echo "** Making $(ESSDIR) directory of ESS for release $(ESSVERSION),"
	@echo "** (must have setup git / github with cached authentication, prior for security)"
	@echo "**********************************************************"
	@echo "** Exporting Files **"
	git clone git@github.com:emacs-ess/ESS.git $(ESSDIR)-git
	mkdir -p $(ESSDIR)
	(cd $(ESSDIR)-git; $(GNUTAR) cvf - --exclude=.git --exclude=.svn --no-wildcards .) | (cd $(ESSDIR); $(GNUTAR) xf - )
	@echo "** Clean-up docs, Make docs, and Correct Write Permissions **"
	CLEANUP="user-* useR-* Why_* README.*"; ED=$(ESSDIR)/doc; \
	 if [ -d $$ED ] ; then CD=`pwd`; cd $$ED; chmod -R u+w $$CLEANUP; rm -rf $$CLEANUP; \
	 $(MAKE) all cleanaux ; cd $$CD; fi
#	just in case: update from VERSION:
	cd lisp; $(MAKE) ess-custom.el; $(INSTALL) ess-custom.el ../$(ESSDIR)/lisp/; cd ..
	cd lisp; $(MAKE) julia-mode.el; $(INSTALL) julia-mode.el ../$(ESSDIR)/lisp/; cd ..
	$(INSTALL) RPM.spec $(ESSDIR)/
	chmod a-w $(ESSDIR)/lisp/*.el
	chmod u+w $(ESSDIR)/lisp/ess-site.el $(ESSDIR)/Make* $(ESSDIR)/*/Makefile
	touch $(ESSDIR)/etc/.IS.RELEASE
#	# Get (the first 12 hexdigits of) the git version into the release tarball:
	cut -c 1-12 $(ESSDIR)-git/.git/refs/heads/master > $(ESSDIR)/etc/git-ref

dist: VERSION tarballs
	grep -E 'defvar ess-(version|revision)' lisp/ess-custom.el \
	  $(ESSDIR)/lisp/ess-custom.el > $@

.PHONY: cleanup-dist cleanup-rel
cleanup-dist:
	@echo "** Cleaning up **"
	rm -f $(ESSDIR)/etc/.IS.RELEASE $(ESSDIR)/etc/git-ref
	(if [ -d $(ESSDIR) ] ; then \
	  chmod -R u+w $(ESSDIR) $(ESSDIR)-git && rm -rf $(ESSDIR) $(ESSDIR)-git; fi)

##  should only be called manually (if at all):
cleanup-rel:
#	@rm -rf $(ESSDIR)*
	@rm -f tarballs dist tag homepage upload rel

%.spec: %.spec.in VERSION
	sed 's/@@VERSION@@/$(ESSVERSION)/g' $< > $@


## --- RELEASE section ---

## NB: Typically use  'make -W VERSION ChangeLog' before 'make rel' <<--- MUST
##	since          ~~~~~~~~~~~~~~~~~~~~~~~~~
## 	ChangeLog often ends up newer than VERSION
ChangeLog: VERSION
	@echo "** Adding log-entry to ChangeLog file"
	mv ChangeLog ChangeLog.old
	(echo `date "+%Y-%m-%d "` \
	     " ESS Maintainers <ESS-core@r-project.org>" ; \
	 echo; echo "  * Version $(ESSVERSION) released."; echo; \
	 cat ChangeLog.old ) > ChangeLog
	@rm ChangeLog.old
	git commit -m 'Version $(ESSVERSION)' ChangeLog


tag:
	@echo "** Tagging the release **  1) pull existing;  2) tag  3) push it"
	git pull --tags
	@echo "Creating tag (no signing, as that fails for MM)"
	git tag -m'release tagging' v$(ESSVERSION)
	@echo '** Pushing the 	v$(ESSVERSION)  upstream ...'
	git push origin v$(ESSVERSION)
	@touch $@

# signing fails for MM (gpg2 / gpg ??) --> use a non-signed tag above

# @echo "Creating tag and signing using $(GPG)"
# git tag -s -m'release tagging' v$(ESSVERSION)

homepage:
	@echo "** Updating ESS Webpage **"
	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
	cd $(ESS_HOMEPAGE); ./update-VERSION $(ESSVERSION)
	@touch $@

upload:
	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
	@echo "** Placing .tgz and .zip files and their .sig's **"
	cp -p $(ESSDIR).tgz $(ESSDIR).tgz.sig $(ESSDIR).zip $(ESSDIR).zip.sig $(UPLOAD_DIR)
	@echo "** Creating LATEST.IS. file **"
	rm -f $(UPLOAD_DIR)/LATEST.IS.*
	touch $(UPLOAD_DIR)/LATEST.IS.$(ESSDIR)
	touch $@

#==== RELEASE : ====

rel: ChangeLog dist tag homepage upload
	@echo "If all is perfect, eventually call   'make cleanup-rel'"
	touch $@


## NB: The rpm (SuSE, RH, FC) and debian packages are built *and* signed
##     by the down stream maintainers:
.PHONY: buildrpm
buildrpm: dist
	rpmbuild -ta --sign $(ESSDIR).tgz

builddeb:
	dpkg-buildpackage -uc -us -rfakeroot -tc

## Old Note (clean and distclean are now the same):
## 'clean'     shall remove *exactly* those things that are *not* in version control
## 'distclean' removes also things in VC (svn, when they are remade by "make"):
clean distclean: cleanup-dist
	cd etc; $(MAKE) $@
	cd lisp; $(MAKE) $@
	cd doc; $(MAKE) $@

=== doc/Makefile ===
### Makefile - for DOCUMENTATION (./doc) of ESS distribution.
###

## Before making changes here, please take a look at Makeconf
include ../Makeconf

# program to convert .texi{nfo} to .html
#MM: use makeinfo (i.e. MAKEHTML from above) which is more
#--  standardized than texi2html which exists in
#MM  at least two widely differing versions (TeX vs GNU):
#MM TEXI2HTML = LANG=C texi2html -verbose -iso
#MM SPLITCHAP = -split_chapter -menu -glossary
##

TEXI2PDF = LANG=C texi2dvi --pdf

# To obtain sorted indices run:	"texindex ess.??".

#### no user servicable parts beyond this point ####

TEXISRC = announc.texi authors.texi bugrept.texi bugs.texi \
	credits.texi currfeat.texi ess.texi ess-defs.texi \
	help-s.texi help-sas.texi installation.texi \
	license.texi mailing.texi onewfeat.texi news.texi onews.texi \
	newfeat.texi requires.texi help-bugs.texi \
        help-jags.texi allnews.texi Makefile ../Makeconf ../VERSION

ESSINFONODE1='* ESS: (ess).'
ESSINFONODE2='	        Emacs Speaks Statistics'
ESSINFONODE3='                        (S/S+/R, SAS, BUGS, Stata, XLisp-Stat).'

### Targets --
PDFs = ess.pdf readme.pdf refcard/refcard.pdf
TXTs = ../README ../ANNOUNCE ../NEWS ../ONEWS

# Don't build pdf/html by default
all  : info text
info : info/ess.info
text : $(TXTs)
html : html/ess.html html/readme.html html/news.html
pdf  : $(PDFs)

ess.pdf : $(TEXISRC)
	$(TEXI2PDF) ess.texi

readme.pdf : $(TEXISRC); $(TEXI2PDF) readme.texi

cleanaux:
	-@rm -f *.aux *.cp *.cps *.fn *.fns *.ky *.kys *.log *.out \
	        *.pg *.pgs *.tmp *.toc *.tp *.vr *.vrs
## this shall remove *exactly* those things that are *not* in version control:
clean: cleanaux
	-@rm -f $(TXTs) $(PDFs) info/*.info* html/*

## this removes also things in VC (svn, when they are remade by "make"):
distclean : clean
#	-@rm -f $(PDFs)

../README: $(TEXISRC)
	-$(MAKETXT) readme.texi \
	| perl -pe 'last if /^Concept Index/;' > $@
#	| perl -pe 'last if /^Concept Index/; print "For INSTALLATION, see way below.\n\n" if /^\s*ESS grew out of/' \

../ANNOUNCE: $(TEXISRC)
	-$(MAKETXT) announc.texi \
	| perl -pe 'last if /^Concept Index/;' > $@

README.Microsoft : README.Microsoft.texi
	$(MAKETXT) README.Microsoft.texi \
	| perl -pe 'last if /^Concept Index/;' > $@

../NEWS: Makefile ess-defs.texi newfeat.texi news.texi
	-$(MAKETXT) news.texi > $@

../ONEWS: Makefile ess-defs.texi onewfeat.texi onews.texi
	-$(MAKETXT) onews.texi > $@

### File Dependencies

info/ess.info: $(TEXISRC) ../VERSION
	@echo "making Info documentation..."
	-$(MAKEINFO) ess.texi
	mv -f ess.info info/

install: install-info install-other-docs

install-info : info/ess.info
	-$(INSTALLDIR) $(INFODIR)
	$(INSTALL) info/ess.info $(INFODIR)
	test -f $(INFODIR)/dir || $(INSTALL) dir.txt $(INFODIR)/dir
	grep $(ESSINFONODE1) $(INFODIR)/dir || \
	(echo >> $(INFODIR)/dir; echo 'Emacs' >> $(INFODIR)/dir; \
	echo $(ESSINFONODE1) $(ESSINFONODE2) >> $(INFODIR)/dir; \
	echo $(ESSINFONODE3) >> $(INFODIR)/dir)

install-other-docs: pdf html
	-$(INSTALLDIR) $(DOCDIR)
	$(INSTALL) ess.pdf readme.pdf $(DOCDIR)
	$(INSTALL) html/ess.html html/readme.html html/news.html $(DOCDIR)
	$(INSTALL) refcard/refcard.pdf $(DOCDIR)

uninstall :
	-cd $(DOCDIR) && $(UNINSTALL) ess.pdf readme.pdf README ANNOUNCE
	-cd $(DOCDIR) && $(UNINSTALL) ess.html readme.html news.html
	-cd $(DOCDIR) && $(UNINSTALL) refcard.pdf

##  TO DO:  ess_toc.html & readme_toc.html should be merged into index.html
html/ess.html: $(TEXISRC)
	@echo "making HTML documentation..."
	mkdir -p html
	-$(MAKEHTML) html/ess.html ess.texi
#MM	$(TEXI2HTML) $(SPLITCHAP) ess.texi
#MM	test -d ess && cp -p ess/ess_toc.html html/index.html || cp -p ess_toc.html html/index.html
#MM	test -d ess && mv -f ess/*.html html || mv -f *.html html

html/readme.html: $(TEXISRC)
	-$(MAKEHTML) html/readme.html --no-validate readme.texi
		 ##                   ^^^^^^^^^^^^^ (design bug: "FIXME" in ess.texi)
#MM	$(TEXI2HTML) readme.texi
#	mv -f readme.html html

html/news.html: $(TEXISRC)
	mkdir -p html
	-$(MAKEHTML) html/news.html allnews.texi

refcard/refcard.pdf: refcard/refcard.tex
	(cd refcard ; pdflatex refcard)

=== etc/Makefile ===
### Makefile - for scripts and icons (./etc) of ESS distribution.
###

## Before making changes here, please take a look at Makeconf
include ../Makeconf

# In ../Makefile we already construct the  ESSR-VERSION  file :
# ESSR_VERSION = $(shell cat ESSR-VERSION)

#ETCFILES = $(wildcard BACKBUG[S5].BAT backbug[s5] *.S sas-keys.*)
#ETCFILES = ESSR.R ess-developer.R SVN-REVISION *.S sas-keys.* ess-sas-sh-command
# ETCFILES_1 = *.S sas-keys.* ess-sas-sh-command *.jl
ETCFILES_1 = ess-sas-sh-command *.jl
isRELEASE=$(shell test -f .IS.RELEASE && echo 'yes')
ifeq ($(isRELEASE),yes)
  ETCFILES = .IS.RELEASE git-ref $(ETCFILES_1)
else
  ETCFILES =                     $(ETCFILES_1)
endif

#ICONS = $(wildcard icons/*.xpm)
ICONS = icons/*.xpm

ESSR_UTIL_FILES = ESSR/LOADREMOTE ESSR/VERSION
ESSR_CODE_FILES = ESSR/R/*.R ESSR/R/.*.R
# ESSR_tarball = ESSR_$(ESSR_VERSION).tar.gz

all: #ESSR-VERSION $(ESSR_tarball) library/ESSR

show-etc:
	@echo $(ETCFILES)
	ls -l $(ETCFILES)


## happens "above" as it is need also in ../lisp/ :
# ESSR-VERSION: $(ESSR_FILES)
#	(cd .. ; make etc/ESSR-VERSION)

# $(ESSR_tarball): $(ESSR_FILES)
#	R CMD build ESSR
# library/ESSR: $(ESSR_tarball)
#	R CMD INSTALL -l library ESSR

# rel:  $(ESSR_tarball)
#	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
#	$(INSTALL) $(ESSR_tarball) $(UPLOAD_DIR)/pkgs/src/contrib

install :
	$(INSTALLDIR) $(ETCDIR)/icons
	$(INSTALLDIR) $(ETCDIR)/ESSR/R
	$(INSTALL) $(ETCFILES) $(ETCDIR)
	$(INSTALL) $(ICONS) $(ETCDIR)/icons
	$(INSTALL) $(ESSR_UTIL_FILES) $(ETCDIR)/ESSR
	$(INSTALL) $(ESSR_CODE_FILES) $(ETCDIR)/ESSR/R
	chmod +x $(ETCDIR)/ess-sas-sh-command

uninstall :
	-cd $(ETCDIR) && $(UNINSTALL) $(ETCFILES)
	-cd $(ETCDIR) && $(UNINSTALL) $(ICONS)
	-cd $(ETCDIR) && $(UNINSTALL) $(ESSR_UTIL_FILES)
	-cd $(ETCDIR) && $(UNINSTALL) $(ESSR_CODE_FILES)



## 'clean'     shall remove *exactly* those things that are *not* in version control
clean distclean:
	rm -rf SVN-REVISION
## 'distclean' removes also things in VC (svn, when they are remade by "make"):
# distclean: clean
#	rm -rf ESSR_*.tar.gz

=== lisp/Makefile ===
### Makefile - for compiled e-lisp of ESS distribution.
###

## Before making changes here, please take a look at Makeconf
include ../Makeconf

## For noweb extraction of code and documentation.

NOTANGLE=notangle -L
#NOTANGLE=notangle for no indexing.
NOWEAVE=noweave

## SUFFIXES are in ../Makeconf :
.nw.html: ;     $(NOWEAVE) -filter l2h -index -html $*.nw > $*.html
.nw.tex: ;      $(NOWEAVE) -index -delay $*.nw | cpif $*.tex
.nw.el:  ;      $(NOTANGLE) -R$*.el | cpif $*.el
##.nw.c:  ;       $(NOTANGLE) -R$*.c | cpif $*.c
##.nw.h:  ;       $(NOTANGLE) -R$*.h | cpif $*.h
.tex.dvi: ;     latex '\scrollmode \input '"$*"; while grep -s 'Rerun to get cross-references right' $*.log; do latex '\scrollmode \input '"$*"; done

# Have to preload the files that contain macro definitions or the byte compiler
# will compile everything that references them incorrectly. Also preload a file
# that sets byte compiler options.
COMPILE = $(EMACSBATCH) --directory . -f batch-byte-compile

ELS = $(wildcard *.el obsolete/*.el)
ELS := $(filter-out ess-autoloads.el, $(ELS))
ELC = $(ELS:.el=.elc)

# ESSR_VER =`cat ../etc/ESSR-VERSION`
##ESSR_VER = $(shell cat ../etc/ESSR-VERSION)

### Targets

all: julia-mode.el $(ELC) ess-custom.el ess-autoloads.el

.PHONY: dist
dist: all

install: dist
	-$(INSTALLDIR) $(LISPDIR)
	$(INSTALL) $(ELC) $(LISPDIR)
	if [ -f /etc/debian_version -a -n "$(SITELISP)" -a ! -f "$(SITELISP)/ess-site.el" ] ; \
	then \
		ln -s $(LISPDIR)/ess-site.el $(SITELISP)/ess-site.el ; \
	fi;
#	test "$(LISPDIR)" = "." || $(INSTALL) *.elc $(LISPDIR)

uninstall:
	-cd $(LISPDIR) && $(UNINSTALL) *.elc *.el
	if [ -n "$(SITELISP)" -a -h "$(SITELISP)/ess-site.el" ] ; \
	then \
		cd $(SITELISP) && $(UNINSTALL) ess-site.el ; \
	fi;

clean:
	rm -f $(ELC)
	rm -f ess-autoloads.el

distclean: clean
# and potentially more

### Targets below here are only for developers - and these must have perl

### Replace Version numbers (as in ../doc/Makefile !):
## "../VERSION" if that changes, *definitely* need to update ess-custom.el
ess-custom.el: ../VERSION
	EV='$(ESSVERSION)'; perl -pi -e "s/\".*\"/\"$$EV\"/ if /ess-version/" $@

# ess-r-mode.el: ../etc/ESSR-VERSION
# 	sed -i -e '/let.*ESSR-version/s/"[-.0-9]*"/"$(ESSR_VER)"/' $@

## Should happen before building ESS; definitely *NOT* after unpacking tarball :
julia-mode.el:
	test -f ../etc/.IS.RELEASE || $(DOWNLOAD) \
	https://raw.githubusercontent.com/JuliaEditorSupport/julia-emacs/master/julia-mode.el > $@

ess-julia.elc: julia-mode.elc

ess-autoloads.el:
	@printf	"\nGenerating $@\n"
	$(EMACSBATCH) --eval "(progn\
	(setq make-backup-files nil)\
	(setq generated-autoload-file (expand-file-name \"$@\"))\
	(setq find-file-visit-truename t)\
	(update-directory-autoloads default-directory))"

### File Dependencies

.el.elc:
	$(COMPILE) $<

ess-custom.elc: ess-custom.el
	$(COMPILE) ess-custom.el

ess.elc: ess.el ess-custom.elc
	$(COMPILE) ess.el

ess-site.elc: ess-site.el ess.elc

ess-inf.elc: ess-inf.el $(CORE)
# 	@echo " "
# 	@echo "For the next compile, please disregard the messages"
# 	@echo " ** the function set-keymap-parent is not known to be defined."
# 	@echo " ** assignment to free variable comint-last-input-end"
# 	@echo "from the byte compiler if they occur. It is completely normal."
	$(COMPILE) ess-inf.el

ess-trns.elc: ess-trns.el $(CORE)
	$(COMPILE) ess-trns.el

ess-help.elc: ess-help.el $(CORE)

## S languages

ess-s-lang.elc : ess-s-lang.el ess.elc

ess-sas-d.elc : ess-sas-d.el ess.elc

ess-s3-d.elc : ess-s3-d.el ess-s-lang.elc ess.elc

ess-sp3-d.elc : ess-sp3-d.el ess-s-lang.elc ess.elc

ess-s4-d.elc : ess-s4-d.el ess-s-lang.elc ess.elc

ess-r-mode.elc : ess-r-mode.el ess-s-lang.elc ess.elc

ess-swv.elc: ess-swv.el ess-noweb.elc

## Lisp Languages

ess-lsp-l.elc : ess-lsp-l.el ess.elc

ess-xls-d.elc : ess-xls-d.el ess-lsp-l.elc ess.elc

ess-vst-d.elc : ess-vst-d.el ess-lsp-l.elc ess.elc

## SAS

ess-sas-l.elc : ess-sas-l.el ess-sas-a.el ess.elc

ess-sas-d.elc : ess-sas-d.el ess-sas-l.elc ess.elc

## Stata

ess-stata-lang.elc : ess-stata-lang.el ess.elc

ess-stata-mode.elc : ess-stata-mode.el ess.elc

## BUGS

ess-bugs-l.elc : ess-bugs-l.el

ess-bugs-d.elc : ess-bugs-d.el ess-bugs-l.elc

## JAGS

ess-jags-d.elc : ess-jags-d.el ess-bugs-l.elc ess-utils.elc ess-inf.elc

## GRETL

ess-gretl.elc : ess-gretl.el

ess-r-gui.elc : ess-r-gui.el ess-dde.elc


# Ignore this.
#(defun S-insert-make-rule (file)
#  (interactive "sFile:")
#  (insert (format "%s.elc:  %s.el $(CORE)\n\t@echo compiling %s.el...\n\t@$(COMPILE) %s.el" file file file file)))

# Use this to print an envvar for debugging purposes.
# Example: make print-EMACS
print-%: ; @echo $* = $($*)

=== test/Makefile ===
EMACS?=emacs

.PHONY: literate


all:
	${EMACS} -Q --script run-tests

ess:
	${EMACS} -Q --script run-tests --ess

inf:
	${EMACS} -Q --script run-tests --inf

r:
	${EMACS} -Q --script run-tests --rstats

r-indent:
	${EMACS} -Q --script run-tests --rstats-indent

literate:
	${EMACS} -Q --script run-tests --literate


cases: indent-cases literate-cases

indent-cases:
	${EMACS} -Q --script generate-indent-cases

literate-cases:
	${EMACS} -Q --script generate-literate-cases

=== debian/changelog ===
ess (18.10.2-2) unstable; urgency=medium

  * debian/control: Change Build-Depends: from texlive-generic-recommended
    to texlive-plain-generic 				(Closes: #941517)

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 03 Oct 2019 12:38:13 -0500

ess (18.10.2-1) unstable; urgency=medium

  * New upstream version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 10 Nov 2018 07:02:07 -0600

=== debian/control ===
Source: ess
Section: gnu-r
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Standards-Version: 4.1.1
Build-Depends: debhelper (>= 10)
Build-Depends-Indep: dh-elpa, texlive-base, texlive-latex-base, texlive-latex-recommended, texlive-latex-extra, texlive-plain-generic, texlive-extra-utils, texlive-fonts-recommended, texinfo
Vcs-Browser: https://salsa.debian.org/edd/ess
Vcs-Git: https://salsa.debian.org/edd/ess.git
Homepage: http://ess.r-project.org

Package: elpa-ess
Architecture: all
Depends: ${misc:Depends}, emacsen-common (>= 2.0.8), dpkg (>= 1.15.4) | install-info
Conflicts: dhelp (<= 0.3.12)
Breaks: ess (<= 17.11-3)
Recommends: r-base-core
Suggests: xlispstat, pspp, jags, julia
Description: Emacs mode for statistical programming and data analysis
 "Emacs Speaks Statistics" (ESS) is an add-on package for emacs text
 editors such as GNU Emacs and XEmacs. It is designed to support
 editing of scripts and interaction with various statistical analysis
 programs such as R, S-Plus, SAS, Stata and OpenBUGS/JAGS.  Although
 all users of these statistical analysis programs are welcome to apply
 ESS, advanced users or professionals who regularly work with
 text-based statistical analysis scripts, with various statistical
 languages/programs, or with different operating systems might benefit
 from it the most.
 .
 The rationale for developing ESS is that most statistical analysis
 systems provide a more or less sophisticated graphical user interface
 (GUI). However, their full power is only available using their
 scripting language. Furthermore, complex statistical analysis
 projects require a high degree of automation and documentation which
 can only be handled by creating statistical analysis
 scripts. Unfortunately, many statistics packages provide only weak
 text editor functionality and show major differences between
 them. Without a unified text editor user interface additional effort
 is required from the user to cope with limited functionality and with
 text editor differences.
 .
 Therefore, emacs editors and the ESS package provide the following
 major features:
  - Support for various operating systems
    Examples: Linux, Unix, Mac OS X and MS Windows
  - Working environment based on emacs
    Examples: File Manager (Dired), File Transfer Client/Telnet Client
    (Tramp), Multiple Clipboards (registers), Bookmarks, Abbreviations,
    and many others
  - Support for various statistical analysis languages
    Examples: R, S-Plus, SAS, Stata and OpenBUGS/JAGS
    Examples: Keybindings, Abbreviations, Syntax highlighting, Code
    formatting, Commenting, Submitting scripts, Displaying results and
    Searching documentation
 .
 ESS is freely available under the GNU General Public License (GPL).
 For further technical and legal information please refer to the ESS
 Manual.

Package: ess
Architecture: all
Depends: ${misc:Depends}, elpa-ess
Description: Transition Package, ess to elpa-ess
 The ESS addon package for Emacs has been elpafied.  This dummy package
 helps ease transition from ess to elpa-ess.

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Christoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=1

## edd 16 May 2008  trivial 'orig.tar.gz' creator
##                  technically, this could be a native Debian package as
##                  the debian/ is in upstream SVN but it is easier to have
##                  another degree of freedom for Debian revisions
##                  if we used just the svn rev: version := $(shell svnversion)
## edd 04 Oct 2008  use changelog entry instead
version := $(shell head -1 debian/changelog | perl -nle 'm/\((\S+)-\d\)/ && print $$1')

showversion:
	@echo Version is ${version}

tarball:
	(cd .. && \
		tar czf tarballs/ess_${version}.orig.tar.gz ess \
			--exclude=.svn \
			--exclude=.git \
			--exclude=debian )

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:
	dh_testdir

	chmod -R u+w *

#	$(MAKE) -C doc ess.dvi
#	$(MAKE) -C doc readme.dvi
#	$(MAKE) -C doc
	(cd doc; $(MAKE) all; $(MAKE) info; $(MAKE) pdf; $(MAKE) html; cd -)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	chmod -R u+w *

	rm -f build-stamp install-stamp doc/*.info*

	[ ! -f Makefile ] || $(MAKE) clean

	rm -f doc/*.dvi #README ANNOUNCE doc/html/readme.html doc/html/ess.html
	rm -f doc/refcard/refcard.log doc/refcard/refcard.aux

	rm -f lisp/ess-pkg.el
	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs

#	cd doc ; $(MAKE) install PREFIX=`pwd`/debian/ess
#	! [ -e debian/ess/usr/share/emacs/site-lisp/ess/ess-site.el ] || \
#	    chmod u+w debian/ess/usr/share/emacs/site-lisp/ess/ess-site.el
#	sed -i -e 's,(defvar ess-etc-directory nil,(defvar ess-etc-directory "/usr/share/ess/etc/",1'\
#	    -e 's,(while (and (listp ess-etc,(while (and (not ess-etc-directory) (listp ess-etc,1' \
#		lisp/ess-site.el
	cp -vax debian/ess-pkg.el lisp/
	dh_elpa
#	mkdir -p debian/elpa-ess/usr/share/ess
#	cp -a etc debian/elpa-ess/usr/share/ess/
	(cd debian/elpa-ess/usr/share/emacs/site-lisp/elpa-src/ess-*/etc/ && rm -f BACKBUGS.BAT ess-sas-sh-command backbug*)

	touch install-stamp

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installemacsen
	dh_installinfo $$(find doc -type f -name "*.info*")
	dh_installchangelogs 
	rm -fv debian/ess/usr/share/doc/elpa-ess/ChangeLog
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-dependent files here.
binary-arch: build install

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
# format version number, currently 2; this line is compulsory!
version=2

# This is one format for an HTTP site, which is the same as the FTP format
http://ess.r-project.org/downloads/ess/ess-([-0-9\.]*).tgz

## ess 18.10.2+git20220915.f45542e

=== Makefile ===
## Top Level Makefile

## Before making changes here, please take a look at Makeconf
include ./Makeconf

ESSVERSION := $(shell cat VERSION)
PKGVERSION := $(shell sed -n 's/;; Version: *\(.*\) */\1/p' lisp/ess.el)
ESSDIR := ess-$(ESSVERSION)
ifneq ($(ESSVERSION), $(PKGVERSION))
  $(shell sed -i 's/Version: .*/Version: $(ESSVERSION)/' VERSION)
  ${shell sed -i 's/;; Version: .*/;; Version: $(ESSVERSION)/' lisp/ess.el}
endif

ESSR-VERSION := $(shell sed -n "s/;; ESSR-Version: *\(.*\) */\1/p" lisp/ess.el)

.PHONY: all
all: lisp doc etc autoloads

.PHONY: version
version:
	@echo "********************* VERSIONS **************************"
	@echo $(shell $(EMACS) --version | sed -n 1p)
	@echo ESS $(ESSVERSION)
	@echo ESSR $(ESSR-VERSION)
	@echo "*********************************************************"

.PHONY: lisp
lisp: version
	$(MAKE) -C lisp all

.PHONY: doc
doc: version
	$(MAKE) -C doc all

.PHONY: etc
etc: version
	$(MAKE) -C etc all

.PHONY: test
test: version
	$(MAKE) -C test all

test-%: version
	$(MAKE) -C test $*

.PHONY: julia
julia:
	@cd lisp; $(MAKE) julia-mode.el

.PHONY: autoloads
autoloads:
	cd lisp; $(MAKE) ess-autoloads.el

## Rebuild and publish ESSR package:
# 1. Update ESSR-Version in lisp/ess.el
# 2. make essr
.PHONY: essr
essr: VERSION
	@echo "**********************************************************"
	@echo "** Making ESSRv$(ESSR-VERSION) **"
	@sed -i "s/^ *VERSION <- .*/    VERSION <- \"$(ESSR-VERSION)\"/" etc/ESSR/R/.load.R
	cd etc/ESSR/; ./BUILDESSR; cd -
	@git add etc/ESSR.rds lisp/ess.el etc/ESSR/R/.load.R
	git commit -m"ESSR Version $(ESSR-VERSION)"
	git tag "ESSRv"$(ESSR-VERSION)
	git push
	git push origin "ESSRv"$(ESSR-VERSION)

install: all
	mkdir -p $(ESSDESTDIR)
	$(INSTALL) -R ./* $(ESSDESTDIR)/

uninstall:
	rm -rf $(ESSDESTDIR)


## the rest of the targets are for ESS developer's use only :
.PHONY: tarballs sign-tarballs
TARBALLS = ess-$(ESSVERSION).tar ess-$(ESSVERSION).tgz ess-$(ESSVERSION).zip # TODO: ess-plus-$(VERSION).tar
tarballs: $(TARBALLS)

SIGNED_TARBALLS = $(addsuffix .sig, $(TARBALLS))
sign-tarballs: $(SIGNED_TARBALLS)
$(SIGNED_TARBALLS): $(TARBALLS)
	@echo "Signing $@"
	$(GPG) -ba -o $@ $<


.PHONY: tgz
tgz: ess-$(ESSVERSION).tgz
ess-$(ESSVERSION).tgz: $(ESSDIR)
	@echo "** Creating .tgz file **"
	test -f $(ESSDIR).tgz && rm -rf $(ESSDIR).tgz || true
	$(GNUTAR) hcvofz $(ESSDIR).tgz $(ESSDIR)

.PHONY: zip
zip: ess-$(ESSVERSION).zip
ess-$(ESSVERSION).zip: $(ESSDIR)
	@echo "** Creating .zip file **"
	test -f $(ESSDIR).zip && rm -rf $(ESSDIR).zip || true
	zip -r $(ESSDIR).zip $(ESSDIR)

.PHONY: package
package: ess-$(ESSVERSION).tar
ess-$(ESSVERSION).tar:
	@echo "Creating $@"
	@rm -rf $(ESSDIR)
	@git archive HEAD -o ess-$(ESSVERSION).tar
	@mkdir ess-$(ESSVERSION)
	@$(GNUTAR) -C ess-$(ESSVERSION) -xf ess-$(ESSVERSION).tar
	@cd ess-$(ESSVERSION) && $(EMACS) -Q --script "targets/create-pkg-file.el"
	@$(GNUTAR) c -f ess-$(ESSVERSION).tar ess-$(ESSVERSION)
	@rm -rf ess-$(ESSVERSION)/

# Create the "release" directory
# run in the foreground so you can accept the certificate
# NB 'all', 'cleanup-dist' must not be targets: otherwise, e.g.
#    'make tarball' re-builds the tarballs always!
$(ESSDIR): RPM.spec
	$(MAKE) all
#	remove previous ESSDIR, etc:
	$(MAKE) cleanup-dist
	@echo "** Exporting Files **"
	git clone . $(ESSDIR)-git
	mkdir -p $(ESSDIR)
	(cd $(ESSDIR)-git; $(GNUTAR) cvf - --exclude=.git --exclude=.svn --no-wildcards .) | (cd $(ESSDIR); $(GNUTAR) xf - )
	@echo "** Clean-up docs, Make docs, and Correct Write Permissions **"
	CLEANUP="user-* useR-* Why_* README.*"; ED=$(ESSDIR)/doc; \
	 if [ -d $$ED ] ; then CD=`pwd`; cd $$ED; chmod -R u+w $$CLEANUP; rm -rf $$CLEANUP; \
	 $(MAKE) all cleanaux ; cd $$CD; fi
#   just in case: update from VERSION:
	cd lisp; $(INSTALL) ess.el ../$(ESSDIR)/lisp/; cd ..
	cd lisp; $(MAKE) julia-mode.el; $(INSTALL) julia-mode.el ../$(ESSDIR)/lisp/; cd ..
	$(INSTALL) RPM.spec $(ESSDIR)/
	chmod a-w $(ESSDIR)/lisp/*.el
	chmod u+w $(ESSDIR)/lisp/ess-site.el $(ESSDIR)/Make* $(ESSDIR)/*/Makefile
	touch $(ESSDIR)/etc/.IS.RELEASE
#	# Get (the first 12 hexdigits of) the git version into the release tarball:
	$(shell git-rev-parse master | cut -c 1-12 ) > $(ESSDIR)/etc/git-ref

dist: VERSION tarballs
	@echo "** Making pdf and html documentation"
	@cd $(ESSDIR)/doc/ ; $(MAKE) pdf
	@cd $(ESSDIR)/doc/ ; $(MAKE) html
	grep -E 'defvar ess-(version|revision)' lisp/ess-custom.el \
	  $(ESSDIR)/lisp/ess-custom.el > $@

.PHONY: cleanup-dist cleanup-rel
cleanup-dist:
	@echo "** Cleaning up **"
	rm -f $(ESSDIR)/etc/.IS.RELEASE $(ESSDIR)/etc/git-ref
	(if [ -d $(ESSDIR) ] ; then \
	  chmod -R u+w $(ESSDIR) $(ESSDIR)-git && rm -rf $(ESSDIR) $(ESSDIR)-git; fi)

##  should only be called manually (if at all):
cleanup-rel:
#	@rm -rf $(ESSDIR)*
	@rm -f tarballs dist tag homepage upload rel

%.spec: %.spec.in VERSION
	sed 's/@@VERSION@@/$(ESSVERSION)/g' $< > $@

## --- RELEASE section ---

ChangeLog: VERSION
	@echo "** Adding log-entry to ChangeLog file"
	mv ChangeLog ChangeLog.old
	(echo `date "+%Y-%m-%d "` \
	     " ESS Maintainers <ESS-core@r-project.org>" ; \
	 echo; echo "  * Version $(ESSVERSION) released."; echo; \
	 cat ChangeLog.old ) > ChangeLog
	@rm ChangeLog.old
	git commit -m 'Version $(ESSVERSION)' ChangeLog

tag:
	@echo "** Tagging the release **  1) pull existing;  2) tag  3) push it"
	git pull --tags
	@echo "Creating tag (no signing, as that fails for MM)"
	git tag -m'release tagging' v$(ESSVERSION)
	@echo '** Pushing the 	v$(ESSVERSION)  upstream ...'
	git push origin v$(ESSVERSION)
	@touch $@

# signing fails for MM (gpg2 / gpg ??) --> use a non-signed tag above

# @echo "Creating tag and signing using $(GPG)"
# git tag -s -m'release tagging' v$(ESSVERSION)

homepage:
	@echo "** Updating ESS Webpage **"
	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
	cd $(ESS_HOMEPAGE); ./update-VERSION $(ESSVERSION)
	@touch $@

upload:
	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
	@echo "** Placing .tgz and .zip files and their .sig's **"
	cp -p $(ESSDIR).tgz $(ESSDIR).tgz.sig $(ESSDIR).zip $(ESSDIR).zip.sig $(UPLOAD_DIR)
	@echo "** Creating LATEST.IS. file **"
	rm -f $(UPLOAD_DIR)/LATEST.IS.*
	touch $(UPLOAD_DIR)/LATEST.IS.$(ESSDIR)
	touch $@

#==== RELEASE : ====

rel: ChangeLog dist tag homepage upload
	@echo "If all is perfect, eventually call   'make cleanup-rel'"
	touch $@


## NB: The rpm (SuSE, RH, FC) and debian packages are built *and* signed
##     by the down stream maintainers:
.PHONY: buildrpm
buildrpm: dist
	rpmbuild -ta --sign $(ESSDIR).tgz

builddeb:
	dpkg-buildpackage -uc -us -rfakeroot -tc

clean distclean: cleanup-dist
	rm -f ess-$(ESSVERSION).tar
	cd etc; $(MAKE) $@
	cd lisp; $(MAKE) $@
	cd doc; $(MAKE) $@

=== doc/Makefile ===
include ../Makeconf

TEXISRC = announc.texi authors.texi bugrept.texi bugs.texi \
	credits.texi currfeat.texi ess.texi ess-defs.texi \
	help-s.texi help-sas.texi installation.texi \
	license.texi mailing.texi onewfeat.texi news.texi onews.texi \
	newfeat.texi requires.texi help-bugs.texi \
        help-jags.texi allnews.texi Makefile ../Makeconf ../VERSION

PDFs = ess.pdf readme.pdf refcard/refcard.pdf
TXTs = ../README ../ANNOUNCE ../NEWS ../ONEWS

# Don't build pdf/html by default
all  : info text
info : info/ess.info
text : $(TXTs)
html : html/ess.html html/readme.html html/news.html
pdf  : $(PDFs)

ess.pdf : $(TEXISRC)
	$(TEXI2PDF) ess.texi

readme.pdf : $(TEXISRC); $(TEXI2PDF) readme.texi

distclean clean:
	@rm -f *.aux *.cp *.cps *.fn *.fns *.ky *.kys *.log *.out \
	        *.pg *.pgs *.tmp *.toc *.tp *.vr *.vrs
	@rm -f $(TXTs) $(PDFs) info/*.info* \
		html/*  *.info dir

../README: $(TEXISRC)
	-$(MAKETXT) readme.texi \
	| perl -pe 'last if /^Concept Index/;' > $@

../ANNOUNCE: $(TEXISRC)
	-$(MAKETXT) announc.texi \
	| perl -pe 'last if /^Concept Index/;' > $@

../NEWS: Makefile ess-defs.texi newfeat.texi news.texi
	-$(MAKETXT) news.texi > $@

../ONEWS: Makefile ess-defs.texi onewfeat.texi onews.texi
	-$(MAKETXT) onews.texi > $@

### File Dependencies

info/ess.info: $(TEXISRC) ../VERSION
	@echo "making Info documentation..."
	-$(MAKEINFO) ess.texi
	mv -f ess.info info/

install: install-info install-other-docs

install-info : info/ess.info
	-$(INSTALLDIR) $(INFODIR)
	$(INSTALL) info/ess.info $(INFODIR)
	$(INSTALL) info/dir $(INFODIR)
	grep $(ESSINFONODE1) $(INFODIR)/dir || \
	(echo >> $(INFODIR)/dir; echo 'Emacs' >> $(INFODIR)/dir; \
	echo $(ESSINFONODE1) $(ESSINFONODE2) >> $(INFODIR)/dir; \
	echo $(ESSINFONODE3) >> $(INFODIR)/dir)

install-other-docs: pdf html
	-$(INSTALLDIR) $(DOCDIR)
	$(INSTALL) ess.pdf readme.pdf $(DOCDIR)
	$(INSTALL) html/ess.html html/readme.html html/news.html $(DOCDIR)
	$(INSTALL) refcard/refcard.pdf $(DOCDIR)

uninstall :
	-cd $(DOCDIR) && $(UNINSTALL) ess.pdf readme.pdf README ANNOUNCE
	-cd $(DOCDIR) && $(UNINSTALL) ess.html readme.html news.html
	-cd $(DOCDIR) && $(UNINSTALL) refcard.pdf

##  TO DO:  ess_toc.html & readme_toc.html should be merged into index.html
html/ess.html: $(TEXISRC)
	@echo "making HTML documentation..."
	mkdir -p html
	-$(MAKEHTML) html/ess.html ess.texi

html/readme.html: $(TEXISRC)
	-$(MAKEHTML) html/readme.html --no-validate readme.texi

html/news.html: $(TEXISRC)
	mkdir -p html
	-$(MAKEHTML) html/news.html allnews.texi

refcard/refcard.pdf: refcard/refcard.tex
	(cd refcard ; pdflatex refcard)

=== etc/Makefile ===
--- 
+++ 
@@ -3,9 +3,6 @@
 
 ## Before making changes here, please take a look at Makeconf
 include ../Makeconf
-
-# In ../Makefile we already construct the  ESSR-VERSION  file :
-# ESSR_VERSION = $(shell cat ESSR-VERSION)
 
 #ETCFILES = $(wildcard BACKBUG[S5].BAT backbug[s5] *.S sas-keys.*)
 #ETCFILES = ESSR.R ess-developer.R SVN-REVISION *.S sas-keys.* ess-sas-sh-command
@@ -21,29 +18,14 @@
 #ICONS = $(wildcard icons/*.xpm)
 ICONS = icons/*.xpm
 
-ESSR_UTIL_FILES = ESSR/LOADREMOTE ESSR/VERSION
+ESSR_UTIL_FILES = ESSR/LOADREMOTE
 ESSR_CODE_FILES = ESSR/R/*.R ESSR/R/.*.R
-# ESSR_tarball = ESSR_$(ESSR_VERSION).tar.gz
 
-all: #ESSR-VERSION $(ESSR_tarball) library/ESSR
+all:
 
 show-etc:
 	@echo $(ETCFILES)
 	ls -l $(ETCFILES)
-
-
-## happens "above" as it is need also in ../lisp/ :
-# ESSR-VERSION: $(ESSR_FILES)
-#	(cd .. ; make etc/ESSR-VERSION)
-
-# $(ESSR_tarball): $(ESSR_FILES)
-#	R CMD build ESSR
-# library/ESSR: $(ESSR_tarball)
-#	R CMD INSTALL -l library ESSR
-
-# rel:  $(ESSR_tarball)
-#	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
-#	$(INSTALL) $(ESSR_tarball) $(UPLOAD_DIR)/pkgs/src/contrib
 
 install :
 	$(INSTALLDIR) $(ETCDIR)/icons

=== lisp/Makefile ===
### Makefile - for compiled e-lisp of ESS distribution.

## Before making changes here, please take a look at Makeconf
include ../Makeconf


### Targets

.PHONY: all dist install uninstall distclean clean compile

JULIAS := julia-mode.el julia-mode-latexsubs.el
ELS = $(filter-out ess-autoloads.el, $(wildcard *.el)) $(JULIAS)
##ELS = $(filter-out ess-autoloads.el, $(wildcard *.el obsolete/*.el)) $(JULIAS)
ELC = $(ELS:.el=.elc)

all dist: compile ess-autoloads.el

compile: $(ELC)

install: dist
	-$(INSTALLDIR) $(LISPDIR)
	$(INSTALL) $(ELS) ess-autoloads.el $(LISPDIR)
	$(INSTALL) $(ELC) $(LISPDIR)
	if [ -f /etc/debian_version -a -n "$(SITELISP)" -a ! -f "$(SITELISP)/ess-site.el" ] ; \
	then \
		ln -s $(LISPDIR)/ess-site.el $(SITELISP)/ess-site.el ; \
	fi;

distclean clean:
	rm -f $(ELC) ess-autoloads.el $(JULIAS) .dependencies


### File Targets

.dependencies: $(ELS)
	@echo Computing dependencies
	@rm -f .dependencies
	@for f in $(ELS); do \
	  sed -n "s|^(require '\(ess.*\)).*$$|$${f}c: \1.elc|p" $${f} >> .dependencies;\
	done
## @for f in obsolete/*.el; do \
##   echo "$$(basename $${f}c):$${f}c" >> .dependencies;\
## done

-include .dependencies

.el.elc:
	$(COMPILE) $<
##obsolete/%.elc: obsolete/%.el
##	$(COMPILE-SIMPLE) $<

JULIA-REPO=https://raw.githubusercontent.com/JuliaEditorSupport/julia-emacs/master
## Should happen before building ESS; definitely *NOT* after unpacking tarball :
$(JULIAS):
	test -f ../etc/.IS.RELEASE || $(DOWNLOAD) $(JULIA-REPO)/julia-mode.el > julia-mode.el
	test -f ../etc/.IS.RELEASE || $(DOWNLOAD) $(JULIA-REPO)/julia-mode-latexsubs.el > julia-mode-latexsubs.el
julia-%.elc: julia-%.el
	$(COMPILE-SIMPLE) $<

ess-autoloads.el:
	@printf	"\nGenerating $@\n"
	$(EMACSBATCH) --eval "(progn\
	(setq make-backup-files nil)\
	(setq generated-autoload-file (expand-file-name \"$@\"))\
	(setq find-file-visit-truename t)\
	(update-directory-autoloads default-directory))"

=== debian/changelog ===
ess (18.10.2+git20220915.f45542e-3) unstable; urgency=medium

  * testsuite.patch: disable ess--command-browser-timeout-test.
    It fails randomly.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 27 Oct 2022 21:12:06 +0200

ess (18.10.2+git20220915.f45542e-2) unstable; urgency=medium

  * testsuite.patch: disable command-without-trailing-newline-test.
    It fails randomly.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 23 Oct 2022 16:10:25 +0200

ess (18.10.2+git20220915.f45542e-1) unstable; urgency=medium

  * New upstream snapshot, compatible with Emacs 28 (Closes: #1017829)
  * Move maintenance to the Debian Emacsen team.
    Many thanks to Dirk Eddelbuettel for his work on this package over the
    years!
  * d/watch: bump format to version 4
  * d/control: use secure URL for Homepage
  * Drop ess transitional package that depends on elpa-ess
  * d/copyright: rewrite using machine-readable format 1.0
  * Move to “editors” archive section, per Debian Emacsen team policy
  * Bump to debhelper compat level 13
  * Add Rules-Requires-Root: no
  * Bump Standards-Version to 4.6.1
  * Ship PDF manual and ANNOUNCE file
  * Overhaul long description
  * refcard-clean.patch: new patch, adds missing clean rules for PDF refcard
  * Add d/upstream/metadata
  * Rewrite d/rules using dh.
  * Honour DEB_BUILD_OPTIONS=nodoc.
  * Exercise testsuite at build time and in an autopkgtest.
    New testsuite.patch for disabling or fixing a few failing tests.
  * Register manual into doc-base

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 16 Oct 2022 12:15:20 +0200

ess (18.10.2-3) unstable; urgency=medium

  * debian/control: Remove alternate dependency on install-info
                                  			(Closes: #1013685)
  * debian/control: Set Standards-Version: to current version 
  * debian/control: Switch to virtual debhelper-compat (= 11)
  * debian/compat: Removed
  * debian/watch: Updated

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 24 Jun 2022 17:23:24 -0500

=== debian/control ===
Source: ess
Section: editors
Priority: optional
Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Standards-Version: 4.6.1
Build-Depends: debhelper-compat (= 13),
               dh-elpa,
               texlive-latex-extra,
               texinfo,
# Build-depend on R for the testsuite
               r-base-core
Vcs-Browser: https://salsa.debian.org/emacsen-team/ess
Vcs-Git: https://salsa.debian.org/emacsen-team/ess.git
Homepage: https://ess.r-project.org
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-elpa

Package: elpa-ess
Architecture: all
Depends: ${misc:Depends},
         ${elpa:Depends}
Enhances: emacs
Recommends: r-base-core
Suggests: pspp, jags
Description: Emacs mode for statistical programming and data analysis
 Emacs Speaks Statistics (ESS) is an add-on package for GNU Emacs. It is
 designed to support editing of scripts and interaction with various
 statistical analysis programs such as R, S, S-Plus, SAS, Stata, BUGS/JAGS and
 Julia.
 .
 It provides the following features:
  - Editing source code (R, S, S-plus, SAS, BUGS/JAGS, Stata, Julia)
    + Syntactic indentation and highlighting of source code
    + Partial evaluation of code
    + Loading and error-checking of code
    + Source code revision maintenance
    + Batch execution (SAS, BUGS/JAGS)
    + Use of imenu to provide links to appropriate functions
  - Interacting with the process (R, S, S-plus, SAS, Stata, Julia)
    + Command-line editing
    + Searchable Command history
    + Command-line completion of R, S, S-plus object names and file names
    + Quick access to object lists and search lists
    + Transcript recording
    + Interface to the help system
  - Transcript manipulation (R, S, S-plus, Stata)
    + Recording and saving transcript files
    + Manipulating and editing saved transcripts
    + Re-evaluating commands from transcript files
  - Interaction with Help Pages and other Documentation (R)
    + Fast Navigation
    + Sending Examples to running ESS process
    + Fast Transfer to Further Help Pages
  - Help File Editing (R)
    + Syntactic indentation and highlighting of source code
    + Sending Examples to running ESS process
    + Previewing

=== debian/watch ===
version=4
https://ess.r-project.org/downloads/ess/ess-([-0-9\.]*).tgz

## ess 18.10.2+git20230419.5c4ae91

=== debian/changelog ===
ess (18.10.2+git20230419.5c4ae91-2) unstable; urgency=medium

  * testsuite.patch: disable more tests (Closes: #1052936)

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 24 Oct 2023 14:05:19 +0200

ess (18.10.2+git20230419.5c4ae91-1) unstable; urgency=medium

  * New upstream snapshot
  * d/copyright: reflect upstream changes
  * refcard-clean.patch: drop patch, applied upstream
  * Trim trailing whitespace.
  * Update standards version to 4.6.2, no changes needed.
  * debian/elpa-test: adapt to upstream testsuite changes
  * testsuite.patch: disable two new tests

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 27 Jun 2023 10:46:46 +0200

## ess 24.01.1

=== Makefile ===
--- 
+++ 
@@ -17,11 +17,12 @@
 all: lisp doc etc autoloads
 
 .PHONY: version
-version:
+version: VERSION
 	@echo "********************* VERSIONS **************************"
 	@echo $(shell $(EMACS) --version | sed -n 1p)
 	@echo ESS $(ESSVERSION)
 	@echo ESSR $(ESSR-VERSION)
+	@sed -i "s/\"VERSION\"/\"$(ESSVERSION)\"/" lisp/ess-custom.el
 	@echo "*********************************************************"
 
 .PHONY: lisp
@@ -77,7 +78,7 @@
 ## the rest of the targets are for ESS developer's use only :
 .PHONY: tarballs sign-tarballs
 TARBALLS = ess-$(ESSVERSION).tar ess-$(ESSVERSION).tgz ess-$(ESSVERSION).zip # TODO: ess-plus-$(VERSION).tar
-tarballs: $(TARBALLS)
+tarballs: $(TARBALLS) 
 
 SIGNED_TARBALLS = $(addsuffix .sig, $(TARBALLS))
 sign-tarballs: $(SIGNED_TARBALLS)
@@ -116,8 +117,8 @@
 # run in the foreground so you can accept the certificate
 # NB 'all', 'cleanup-dist' must not be targets: otherwise, e.g.
 #    'make tarball' re-builds the tarballs always!
-$(ESSDIR): RPM.spec
-	$(MAKE) all
+$(ESSDIR): RPM.spec autoloads
+	$(MAKE) all 
 #	remove previous ESSDIR, etc:
 	$(MAKE) cleanup-dist
 	@echo "** Exporting Files **"
@@ -132,6 +133,7 @@
 	cd lisp; $(INSTALL) ess.el ../$(ESSDIR)/lisp/; cd ..
 	cd lisp; $(MAKE) julia-mode.el; $(INSTALL) julia-mode.el ../$(ESSDIR)/lisp/; cd ..
 	$(INSTALL) RPM.spec $(ESSDIR)/
+	$(INSTALL) lisp/ess-autoloads.el $(ESSDIR)/lisp/
 	chmod a-w $(ESSDIR)/lisp/*.el
 	chmod u+w $(ESSDIR)/lisp/ess-site.el $(ESSDIR)/Make* $(ESSDIR)/*/Makefile
 	touch $(ESSDIR)/etc/.IS.RELEASE
@@ -174,7 +176,8 @@
 
 tag:
 	@echo "** Tagging the release **  1) pull existing;  2) tag  3) push it"
-	git pull --tags
+	git fetch --tags
+##	git pull --tags
 	@echo "Creating tag (no signing, as that fails for MM)"
 	git tag -m'release tagging' v$(ESSVERSION)
 	@echo '** Pushing the 	v$(ESSVERSION)  upstream ...'

=== doc/Makefile ===
--- 
+++ 
@@ -25,6 +25,7 @@
 distclean clean:
 	@rm -f *.aux *.cp *.cps *.fn *.fns *.ky *.kys *.log *.out \
 	        *.pg *.pgs *.tmp *.toc *.tp *.vr *.vrs
+	@rm -f refcard/*.aux refcard/*.log
 	@rm -f $(TXTs) $(PDFs) info/*.info* \
 		html/*  *.info dir

=== test/Makefile ===

include ../Makeconf

.PHONY: literate all julia lisp ess inf org r r-indent literate cases indent-cases literate-cases

all: compile lisp

julia:
	@$(MAKE) -C .. julia

lisp: julia
	${EMACS} -Q --script run-tests

ess:
	${EMACS} -Q --script run-tests --ess

inf:
	${EMACS} -Q --script run-tests --inf

org:
	${EMACS} -Q --script run-tests --org

r r-core:
	${EMACS} -Q --script run-tests --r-core

r-indent:
	${EMACS} -Q --script run-tests --r-indent

r-pkg:
	${EMACS} -Q --script run-tests --r-pkg

literate:
	${EMACS} -Q --script run-tests --literate

cases: indent-cases literate-cases

indent-cases:
	${EMACS} -Q --script generate-indent-cases

literate-cases:
	${EMACS} -Q --script generate-literate-cases

.PHONY: compile
compile:
	@cd .. && make -k lisp \
		"COMPILE-FLAGS = --eval \"(setq byte-compile-error-on-warn t)\""

=== debian/changelog ===
ess (24.01.1-5) unstable; urgency=medium

  * Team upload
  * testsuite.patch: disable ess-r-project-auto-activation-test
    (Closes: #1099229)
  * Remove myself from Uploaders
  * Bump S-V to 4.7.2

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 27 Mar 2025 10:48:32 +0100

ess (24.01.1-4) unstable; urgency=medium

  * Team upload.
  * Rebuild against dh-elpa 2.1.5.
    Upload pushed to dgit-repos but not salsa.
    See <https://lists.debian.org/debian-emacsen/2024/07/msg00077.html>.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 25 Jul 2024 20:24:07 +0900

ess (24.01.1-3) unstable; urgency=medium

  * testsuite.patch: disable two more tests that fail on buildds

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 29 May 2024 14:21:36 +0200

ess (24.01.1-2) unstable; urgency=medium

  * testsuite.patch: fix two tests in ess-test-inf.el.
    The “Browse[…]” prompts numbering has apparently changed.
    (Closes: #1071306)
  * Bump Standards-Version to 4.7.0

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 29 May 2024 11:37:49 +0200

ess (24.01.1-1) unstable; urgency=medium

  * New upstream version 24.01.1 (Closes: #1064388)
  * d/watch: point to GitHub tags page.
    Latest upstream tarball was not uploaded to the traditional location, and
    moreover the upstream tarball available for download on the website contains
    spurious files.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 28 Feb 2024 10:28:41 +0100

ess (24.01.0-1) unstable; urgency=medium

  * New upstream version 24.01.0
  * d/watch: fix matching of tarball extension
  * d/gbp.conf: switch back to using upstream tarballs
  * d/copyright: reflect upstream changes
  * Ship the NEWS file

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 31 Jan 2024 14:12:47 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Section: editors
 Priority: optional
 Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
-Uploaders: Sébastien Villemot <sebastien@debian.org>
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13),
                dh-elpa,
                texlive-latex-extra,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with elpa

override_dh_auto_build:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	make -C doc all html pdf
endif

# Skip byte compilation by upstream build system
override_dh_auto_install:

override_dh_auto_clean:
	make -C doc clean
	rm -f .Rhistory # Generated by the testsuite

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain" \
    https://api.github.com/repos/emacs-ess/ESS/tags?per_page=100 \
    https://api.github.com/repos/emacs-ess/ESS/tarball/refs/tags/@ANY_VERSION@
